// DiskSpace.h: interface for the CDiskSpace class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_DISKSPACE_H__9EACEC21_A216_11D4_B8C4_BF53AAE87C41__INCLUDED_)
#define AFX_DISKSPACE_H__9EACEC21_A216_11D4_B8C4_BF53AAE87C41__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDiskSpace  
{
public:
	CDiskSpace();
	virtual ~CDiskSpace();

	BOOL GetDiskSpace(float &fOut,int nIndex,LPCTSTR lpszFormat=_T("mb"));
	BOOL GetDiskSpace(float &fOut,LPCTSTR lpszDisk,LPCTSTR lpszFormat=_T("mb"));

	BOOL GetDiskFreeSpace(float &fOut,int nIndex,LPCTSTR lpszFormat=_T("mb"));
	BOOL GetDiskFreeSpace(float &fOut,LPCTSTR lpszDisk,LPCTSTR lpszFormat=_T("mb"));

protected:
	BOOL ModifyResult(float &fOut,LPCTSTR lpszFormat);
	void Refresh() { dwDrivesMask=::GetLogicalDrives(); }
	BOOL CheckFormat(LPCTSTR lpszFormat);
	BOOL CheckIndex(int nIndex);
	BOOL GetData(float &fOut,int nIndex,BOOL bFreeSpace=TRUE);

protected:
	DWORD dwDrivesMask;
};

#endif // !defined(AFX_DISKSPACE_H__9EACEC21_A216_11D4_B8C4_BF53AAE87C41__INCLUDED_)
