// DiskSpaceDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DiskSpaceDemo.h"
#include "DiskSpaceDemoDlg.h"
#include "DiskSpace.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiskSpaceDemoDlg dialog

CDiskSpaceDemoDlg::CDiskSpaceDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDiskSpaceDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDiskSpaceDemoDlg)
	m_nFormat = 0;
	m_nSpaceType = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDiskSpaceDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDiskSpaceDemoDlg)
	DDX_Control(pDX, IDC_COMBO1, m_cboDrives);
	DDX_Radio(pDX, IDC_MB, m_nFormat);
	DDX_Radio(pDX, IDC_TOTALSPACE, m_nSpaceType);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDiskSpaceDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDiskSpaceDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDC_MB, OnMb)
	ON_BN_CLICKED(IDC_KB, OnKb)
	ON_BN_CLICKED(IDC_BYTES, OnBytes)
	ON_BN_CLICKED(IDC_FREESPACE, OnFreespace)
	ON_BN_CLICKED(IDC_TOTALSPACE, OnTotalspace)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDiskSpaceDemoDlg message handlers

BOOL CDiskSpaceDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

	DWORD dwDrivesMask = GetLogicalDrives();
	CString strDrive;
	for (int i=0; i<32 ; i++) {
		if (dwDrivesMask & 0x00000001) {
			TCHAR tch = _T('A') + i;
			strDrive.Format("%c:\\",tch);
			m_cboDrives.AddString(strDrive);
			dwDrivesMask >>= 1;
		}
	}


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDiskSpaceDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDiskSpaceDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDiskSpaceDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDiskSpaceDemoDlg::OnSelchangeCombo1() 
{
	int nIndex = m_cboDrives.GetCurSel();
	if (nIndex==CB_ERR || nIndex==-1)
	{
		GetDlgItem(IDC_DISK)->SetWindowText(_T(""));
		GetDlgItem(IDC_RESULTS)->SetWindowText(_T(""));
		return;
	}
	CString strDisk;
	m_cboDrives.GetLBText(nIndex,strDisk);

	GetDlgItem(IDC_DISK)->SetWindowText(strDisk);
//	AfxMessageBox(strDisk);
	FindSpace();

}

void CDiskSpaceDemoDlg::OnMb() 
{
	m_nFormat = 0;
	FindSpace();
}
void CDiskSpaceDemoDlg::OnKb() 
{
	m_nFormat = 1;
	FindSpace();	
}
void CDiskSpaceDemoDlg::OnBytes() 
{
	m_nFormat = 2;
	FindSpace();	
}

void CDiskSpaceDemoDlg::OnTotalspace() 
{
	m_nSpaceType = 0;
	FindSpace();	
}
void CDiskSpaceDemoDlg::OnFreespace() 
{
	m_nSpaceType = 1;
	FindSpace();	
}

void CDiskSpaceDemoDlg::FindSpace()
{
	BOOL bFreeSpace = (m_nSpaceType==0) ? FALSE : TRUE;
	CString strFormat;
	switch (m_nFormat)
	{
	case 0:	strFormat = _T("mb");
		break;
	case 1:	strFormat = _T("kb");
		break;
	case 2:	strFormat = _T("bytes");
		break;
	}
	
	CString strDisk;
	GetDlgItem(IDC_DISK)->GetWindowText(strDisk);
	if (!strDisk.GetLength() || !strFormat.GetLength())
		return; // invalid variables

	float fData=0;
	BOOL bResult=FALSE;
	CString prefix; 
	CDiskSpace ds;

	if (bFreeSpace) {
		prefix = _T("free");
		bResult= ds.GetDiskFreeSpace(fData,strDisk,strFormat);
	}
	else {
		prefix =_T("total");
		bResult= ds.GetDiskSpace(fData,strDisk,strFormat);
	}

	if (bResult)
	{
		CString tmp;
		tmp.Format("%s %s space = %.2f %s",strDisk,prefix,fData,strFormat);
		GetDlgItem(IDC_RESULTS)->SetWindowText(tmp);
	}
	else 
		GetDlgItem(IDC_RESULTS)->SetWindowText(_T("Unknown"));

}


